Ruby: include/ruby/internal/intern/range.h File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Functions
range.h File Reference

Public APIs related to rb_cRange. More...

`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/value.h"`

Go to the source code of this file.

## Functions
VALUE | rb_range_new (VALUE, VALUE, int)
VALUE | rb_range_beg_len (VALUE, long *, long *, long, int)
int | rb_range_values (VALUE range, VALUE *begp, VALUE *endp, int *exclp)

## Detailed Description

Public APIs related to rb_cRange.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file range.h.

## Function Documentation

## ◆ rb_range_beg_len()

VALUE rb_range_beg_len | ( | VALUE | range,
|  | long * | begp,
|  | long * | lenp,
|  | long | len,
|  | int | err
| ) |  |

Definition at line 1398 of file range.c.

References err, len, NIL_P, PRIsVALUE, Qfalse, range, rb_eRangeError, rb_raise(), rb_range_component_beg_len(), and rb_range_values().

Referenced by rb_get_values_at().

## ◆ rb_range_new()

VALUE rb_range_new | ( | VALUE | beg,
|  | VALUE | end,
|  | int | exclude_end
| ) |  |

Definition at line 68 of file range.c.

References range, rb_cRange, rb_obj_alloc(), and RBOOL.

## ◆ rb_range_values()

int rb_range_values | ( | VALUE | range,
|  | VALUE * | begp,
|  | VALUE * | endp,
|  | int * | exclp
| ) |  |

Definition at line 1310 of file range.c.

References EXCL, Qfalse, Qtrue, Qundef, range, rb_cArithSeq, rb_check_funcall(), rb_cRange, rb_intern(), rb_obj_is_kind_of(), and RTEST.

Referenced by rb_arithmetic_sequence_extract(), and rb_range_beg_len().